package lk.sliit.research.interviewapp.controller;

import lk.sliit.research.interviewapp.model.dto.request.TestRequestDto;
import lk.sliit.research.interviewapp.model.dto.response.TestResponseDto;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import static lk.sliit.research.interviewapp.util.Constant.APP_NAME;
import static lk.sliit.research.interviewapp.util.Constant.ERROR_LOG;

@Slf4j
@RestController
@RequestMapping("test")
public class TestController {

    @GetMapping
    public ModelAndView test(){
        ModelAndView modelAndView = new ModelAndView();

        try{
            modelAndView.setViewName("test");
            modelAndView.addObject("text", APP_NAME);
        }
        catch (Exception e){
            modelAndView.setViewName("error/page");
            modelAndView.addObject("error", e.getMessage());
            log.error(ERROR_LOG, e);
        }
        return modelAndView;
    }

    @GetMapping("sample/login")
    public ModelAndView sampleLogin(){
        ModelAndView modelAndView = new ModelAndView();

        try{
            modelAndView.setViewName("sample/login");
            modelAndView.addObject("text", APP_NAME);
        }
        catch (Exception e){
            modelAndView.setViewName("error/page");
            modelAndView.addObject("error", e.getMessage());
            log.error(ERROR_LOG, e);
        }
        return modelAndView;
    }

    @GetMapping("sample/page")
    public ModelAndView samplePage(){
        ModelAndView modelAndView = new ModelAndView();

        try{
            modelAndView.setViewName("sample/page");
            modelAndView.addObject("text", APP_NAME);
        }
        catch (Exception e){
            modelAndView.setViewName("error/page");
            modelAndView.addObject("error", e.getMessage());
            log.error(ERROR_LOG, e);
        }
        return modelAndView;
    }

    @GetMapping("add")
    public ModelAndView addTestView(){
        ModelAndView modelAndView = new ModelAndView();

        try{
            modelAndView.addObject("text", APP_NAME);
            modelAndView.setViewName("test/add");
        }
        catch (Exception e){
            modelAndView.setViewName("error/page");
            modelAndView.addObject("error", e.getMessage());
            log.error(ERROR_LOG, e);
        }
        return modelAndView;
    }

    @PostMapping("create")
    public TestResponseDto createTest(@RequestBody TestRequestDto request){
        log.info("createTest");

        TestResponseDto response = new TestResponseDto();
        try{
            response.setSuccess(true);
            response.setMessage("Hello " + request.getFirstName() + " " + request.getLastName());
        }
        catch (Exception e){
            log.error(ERROR_LOG, e);
            response.setSuccess(false);
            response.setMessage("Error: " + e.getMessage());
        }

        return response;
    }

}
