<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        int year = Calendar.getInstance().get(Calendar.YEAR);
    %>

    <input type="hidden" id="getQuestionUrl" value=<%=baseUrl+"/interview/getQuestion" %>>

    <input type="hidden" id="interViewId" value="1">
    <input type="hidden" id="previousQuestionId" value="1">

    <div id="errorInterviewPanelAlert" style="display: none">
        <div class="alert alert-danger alert-dismissible fade show" role="alert">
          <strong id="errorInterviewPanelAlertMsg">Error</strong>
          <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeErrorInterviewPanelAlert()">x</button>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                <h1>Welcome to the interview!</h1>
                <div class="row">
                    <div class="col-md-12">
                        <div class="card">
                          <div class="card-header">
                            Question
                          </div>
                          <div class="card-body">
                            <blockquote class="blockquote mb-0">
                              <p id="question">Test Question</p>
                            </blockquote>
                          </div>
                        </div>
                    </div>
                </div>
                <br/>
                <div class="row">
                    <div class="col-md-12">
                        <div class="card">
                          <div class="card-header">
                            Answer <b>You cannot skip a question, if you do not wish to answer leave a blank.</b>
                          </div>
                          <div class="card-body">
                            <blockquote class="blockquote mb-0">
                                <textarea class="form-control" id="answer"></textarea>
                            </blockquote>
                          </div>
                        </div>
                    </div>
                </div>
                <br/>
                <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                  <button class="btn btn-info" type="button" onclick="getQuestion()">Next Question</button>
                </div>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>

<script>
    function getQuestion(){
        let interViewId = document.getElementById("interViewId").value;
        let previousQuestionId = document.getElementById("previousQuestionId").value;
        let answer = document.getElementById("answer").value;

        let request = new GetQuestionRequestDto(interViewId,previousQuestionId,answer);
        let jsonRequest = JSON.stringify(request);
        console.log("Request: " + request);
        console.log("Json Request: " + jsonRequest);

		$.ajax({
            type: "POST",
            url: $('input#getQuestionUrl').val(),
            contentType: 'application/json',
            data: jsonRequest,
            success: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                if(obj.question == "ERROR"){
                    document.getElementById("errorInterviewPanelAlert").style.display = "block";
                    document.getElementById("errorInterviewPanelAlertMsg").innerHTML = "Error: Couldn't load question, please try again...";
                }
                else{
                    document.getElementById("errorInterviewPanelAlert").style.display = "none";
                    document.getElementById("question").innerHTML = obj.question;
                    document.getElementById("previousQuestionId").value = obj.questionId;
                    document.getElementById("answer").value = "";
                }
            }, error: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                document.getElementById("errorInterviewPanelAlert").style.display = "block";
                document.getElementById("errorInterviewPanelAlertMsg").innerHTML = "Error: Couldn't load question, please try again...";
            }
        });
    }

    function closeErrorInterviewPanelAlert() {
        document.getElementById("errorInterviewPanelAlert").style.display = "none";
    }

    function GetQuestionRequestDto(interViewId,previousQuestionId,answer) {
        this.interViewId = interViewId;
        this.previousQuestionId = previousQuestionId;
        this.answer = answer;
    }
</script>