<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<html>
<head>
    <title>Add Test</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body>
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
    %>
    <div class="container">
        <h1>Sample Request and Response handling</h1>
        <input type="hidden" id="url" value=<%=baseUrl+"/test/create" %>>
        <input type="hidden" id="replaceUrl" value=<%=baseUrl+"/test" %>>
        <input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}" />

        <input type="text" id="firstName" placeholder="first name">
        <input type="text" id="lastName" placeholder="last name">
        <button class="btn btn-info" onclick="create()">Create</button>
    </div>
</body>
</html>

<script type="text/javascript">
    function create(){
        try {
            let firstName = $('#firstName').val();
            let lastName = $('#lastName').val();
            console.log("firstName: " + firstName);
            console.log("lastName: " + lastName);

            let request = new TestRequestDto(firstName, lastName);
            let jsonRequest = JSON.stringify(request);
            console.log("Request: " + request);
            console.log("Json Request: " + jsonRequest);

            $.ajax({
                type: "POST",
                url: $('input#url').val(),
                contentType: 'application/json',
                data: jsonRequest,
                success: function (response) {
                    let jsonResponse = JSON.stringify(response);
                    let obj = JSON.parse(jsonResponse);

                    console.log("success: " + obj.success);
                    console.log("message: " + obj.message);
                    console.log("Response: " + jsonResponse);

                    alert("Message from server: " + obj.message);

                    // If need to render anything in the same page
                    // Get the value
                    // Use JS or JQuery to render in the page

                    // OR

                    // If need to redirect to another page
                    // Use below function
                    location.reload();
                    window.location.href = $('#replaceUrl').val();
                }, error: function (response) {
                    let jsonResponse = JSON.stringify(response);
                    let obj = JSON.parse(jsonResponse);

                    console.log("success: " + obj.success);
                    console.log("message: " + obj.message);
                    console.log("Response: " + jsonResponse);

                    alert("Message from server: " + obj.message);

                    location.reload();
                    window.location.href = $('#replaceUrl').val();
                }
            });
        }
        catch(err) {
          console.log(err.message);
        }
    }

    function TestRequestDto(firstName,lastName) {
        this.firstName = firstName;
        this.lastName = lastName;
    }
</script>