package lk.sliit.research.interviewapp.Repository;

import lk.sliit.research.interviewapp.model.domain.Interview;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface InterviewRepository extends CrudRepository<Interview, Integer> {
    @Query(value = "SELECT COUNT(i.id) FROM interview i WHERE i.key_pw = ?1", nativeQuery = true)
    int countInterviewByGivenKey(String key);
    @Query(value = "SELECT * FROM `interview` WHERE `room_id` = ?1 AND `key_pw` = ?2 AND `status` = 'INITIAL'", nativeQuery = true)
    Interview findByRoomIdAndKey(String roomId, String key);
    Interview findByCandidateId(int candidateId);
    @Query(value = "SELECT * FROM `interview` WHERE `status` = 'INTERVIEW_OVER' LIMIT ?1",nativeQuery = true)
    List<Interview> viewInterviewForAnalysis(int limit);
    @Query(value = "SELECT * FROM `interview` WHERE `room_id` = ?1 AND `key_pw` = ?2", nativeQuery = true)
    Interview findByRoomIdAndKeyNotInInitial(String roomId, String key);
}
