package lk.sliit.research.interviewapp.Service.impl;

import lk.sliit.research.interviewapp.Repository.CandidateRepository;
import lk.sliit.research.interviewapp.Service.CandidateService;
import lk.sliit.research.interviewapp.model.domain.Candidate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

import static lk.sliit.research.interviewapp.util.Constant.CANDIDATE_STATUS_INITIAL;

@Service
public class CandidateServiceImpl implements CandidateService {

    @Autowired
    CandidateRepository candidateRepository;

    @Override
    public boolean createCandidate(Candidate candidate) {
        candidate.setResumeAnalysis(CANDIDATE_STATUS_INITIAL);
        candidate.setScore(0);

        candidateRepository.save(candidate);
        return true;
    }

    @Override
    public boolean updateCandidate(Candidate candidate) {
        candidateRepository.save(candidate);
        return true;
    }

    @Override
    public List<Candidate> viewAllCandidatesByJobId(int jobId) {
        return candidateRepository.viewAllCandidatesByJobId(jobId);
    }

    @Override
    public Candidate getCandidateById(int candidateId) {
        return candidateRepository.findById(candidateId).get();
    }

    @Override
    public List<Candidate> viewCandidateForResumeAnalysis(int limit) {
        return candidateRepository.viewCandidateForResumeAnalysis(limit);
    }
}
