package lk.sliit.research.interviewapp.Service.impl;

import lk.sliit.research.interviewapp.Repository.JobRepository;
import lk.sliit.research.interviewapp.Service.JobService;
import lk.sliit.research.interviewapp.model.domain.Job;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static lk.sliit.research.interviewapp.util.Constant.DATE_FORMAT;

@Service
public class JobServiceImpl implements JobService {
    @Autowired
    JobRepository jobRepository;

    @Override
    public boolean isUniqueName(String name) {
        int count = jobRepository.countJobNameByGivenName(name);
        return (count == 0);
    }

    @Override
    public boolean createJob(Job job) {
        Date date = new Date();
        SimpleDateFormat formatter = new SimpleDateFormat(DATE_FORMAT);
        String dateStr = formatter.format(date);
        job.setDate(dateStr);
        jobRepository.save(job);
        return true;
    }

    @Override
    public List<Job> listAllJobs() {
        List<Job> jobList = new ArrayList<>();
        jobRepository.findAll().forEach(job -> {
            jobList.add(job);
        });
        return jobList;
    }

    @Override
    public List<Job> filterJobsOnName(String name) {
        return jobRepository.filterJobsOnName(name);
    }

    @Override
    public Job updateJob(Job job) {
        return jobRepository.save(job);
    }

    @Override
    public Job getJobById(int jobId) {
        return jobRepository.findById(jobId).get();
    }
}
