package lk.sliit.research.interviewapp.Service.impl;

import lk.sliit.research.interviewapp.Repository.QnaInterviewRepository;
import lk.sliit.research.interviewapp.Service.QnaInterviewService;
import lk.sliit.research.interviewapp.model.domain.QnaInterview;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

import static lk.sliit.research.interviewapp.util.Constant.QNA_STATUS_INITIAL;

@Service
public class QnaInterviewServiceImpl implements QnaInterviewService {
    @Autowired
    QnaInterviewRepository qnaInterviewRepository;

    @Override
    public boolean saveQnaCandidate(QnaInterview qnaInterview) {
        qnaInterviewRepository.save(qnaInterview);
        return true;
    }

    @Override
    public boolean addInterviewAnswer(int interviewId, int qnaId, String answer) {
        QnaInterview qnaInterview = new QnaInterview();
        qnaInterview.setInterviewId(interviewId);
        qnaInterview.setQnaId(qnaId);
        qnaInterview.setAnswer(answer);
        qnaInterview.setScore(0);
        qnaInterview.setStatus(QNA_STATUS_INITIAL);

        return saveQnaCandidate(qnaInterview);
    }

    @Override
    public List<QnaInterview> findByInterviewId(int interviewId) {
        return qnaInterviewRepository.findByInterviewId(interviewId);
    }

    @Override
    public boolean saveOrUpdateBatchQnaInterview(List<QnaInterview> qnaInterviewList) {
        qnaInterviewRepository.saveAll(qnaInterviewList);
        return true;
    }
}
