<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        String error = (String) request.getAttribute("error");
        int jobId = (int) request.getAttribute("jobId");
        int year = Calendar.getInstance().get(Calendar.YEAR);
    %>

    <div class="row">
        <div class="col-md-12">
            <%@include file="../common/adminHeader.jsp" %>
        </div>
    </div>

    <input type="hidden" id="createCandidateUrl" value=<%=baseUrl+"/candidate/createCandidate" %>>
    <input type="hidden" id="replaceCreateCandidateUrl" value=<%=baseUrl+"/candidate/viewAllCandidates/"+jobId %>>
    <%
        if(error == null || error.isEmpty()){
            %>
                <div id="candidateCreationAlert" style="display: none">
                    <div class="alert alert-danger alert-dismissible fade show" role="alert">
                      <strong id="candidateCreationAlertMsg"></strong>
                      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeCandidateCreationAlert()">x</button>
                    </div>
                </div>
            <%
        }
        else{
            %>
                <div id="candidateCreationAlert">
                    <div class="alert alert-danger alert-dismissible fade show" role="alert">
                      <strong id="candidateCreationAlertMsg"><%=error%></strong>
                      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeCandidateCreationAlert()">x</button>
                    </div>
                </div>
            <%
        }
    %>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                  <h1>Add Candidate Details</h1>
                  <input type="hidden" id="jobId" value=<%=jobId%>>
                  <div class="mb-3">
                    <label for="firstName" class="form-label">First Name</label>
                    <input type="text" class="form-control" id="firstName">
                  </div>
                  <div class="mb-3">
                    <label for="lastName" class="form-label">Last Name</label>
                    <input type="text" class="form-control" id="lastName">
                  </div>
                  <div class="mb-3">
                    <label for="email" class="form-label">Email</label>
                    <input type="email" class="form-control" id="email">
                  </div>
                  <div class="mb-3">
                    <label for="phone" class="form-label">Phone</label>
                    <input type="text" class="form-control" id="phone" maxlength="10">
                  </div>
                  <button class="btn btn-info" onclick="createCandidate()">Add Candidate</button>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>

<script>
    function createCandidate(){
        let firstName = $('#firstName').val();
        let lastName = $('#lastName').val();
        let jobId = $('#jobId').val();
        let email = $('#email').val();
        let phone = $('#phone').val();

        console.log("firstName: " + firstName);
        console.log("lastName: " + lastName);
        console.log("jobId: " + jobId);
        console.log("email: " + email);
        console.log("phone: " + phone);

        if (firstName.length == 0) {
           alert("First name is required!");
           return false;
        }

        if (lastName.length == 0) {
           alert("Last name is required!");
           return false;
        }

        if (email.length == 0) {
           alert("Email is required!");
           return false;
        }

        if (!(/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(email))){
            alert("You have entered an invalid email address!")
            return false;
        }

        if (phone.length != 10 || isNaN(phone)) {
           alert("Phone number is invalid!");
           return false;
        }

        let request = new getCandidateModel(firstName,lastName,jobId,email,phone);
        let jsonRequest = JSON.stringify(request);
        console.log("Request: " + request);
        console.log("Json Request: " + jsonRequest);

		$.ajax({
            type: "POST",
            url: $('input#createCandidateUrl').val(),
            contentType: 'application/json',
            data: jsonRequest,
            success: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                if(obj){
                    // candidate created success
                    location.reload();
                    window.location.href = $('#replaceCreateCandidateUrl').val();
                }
                else{
                    document.getElementById("candidateCreationAlert").style.display = "block";
                    document.getElementById("candidateCreationAlertMsg").innerHTML = "Error in candidate creation!";
                }
            }, error: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                document.getElementById("candidateCreationAlert").style.display = "block";
                document.getElementById("candidateCreationAlertMsg").innerHTML = "Error in candidate creation!";
            }
        });
    }

    function getCandidateModel(firstName,lastName,jobId,email,phone) {
        this.firstName = firstName;
        this.lastName = lastName;
        this.jobId = jobId;
        this.email = email;
        this.phone = phone;
    }

    function closeCandidateCreationAlert() {
        document.getElementById("candidateCreationAlert").style.display = "none";
    }
</script>