<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<%@ page import="java.util.List"%>
<%@ page import="lk.sliit.research.interviewapp.model.domain.Candidate"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        int year = Calendar.getInstance().get(Calendar.YEAR);
        int jobId = (int) request.getAttribute("jobId");
        List<Candidate> candidateList = (List<Candidate>) request.getAttribute("candidateList");
    %>

    <div class="row">
        <div class="col-md-12">
            <%@include file="../common/adminHeader.jsp" %>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                  <div class="row">
                    <div class="col-md-12">
                        <h1 class="float-left">Candidate List</h1>
                        <a class="btn btn-info float-right mt-2" href=<%= baseUrl + "/job/listAllJobsView" %>>Jobs</a>
                        <a class="btn btn-info float-right mt-2" href=<%= baseUrl + "/candidate/addCandidateView/"+jobId %>>Add Candidate</a>
                    </div>
                  </div>
                  <table class="table table-striped table-bordered" style="width:100%">
                    <thead>
                        <tr>
                            <th scope="col">#</th>
                            <th scope="col">ID</th>
                            <th scope="col">First Name</th>
                            <th scope="col">Last Name</th>
                            <th scope="col">Email</th>
                            <th scope="col">Phone No</th>
                            <th scope="col">Resume Score</th>
                            <th scope="col">Actions</th>
                        </tr>
                    </thead>
                    <tbody>
                      <%
                        int i = 1;
                        for(Candidate candidate : candidateList){
                            %>
                            <tr>
                                <th scope="row"><%= i %></th>
                                <td><%= candidate.getId() %></td>
                                <td><%= candidate.getFirstName() %></td>
                                <td><%= candidate.getLastName() %></td>
                                <td><%= candidate.getEmail() %></td>
                                <td><%= candidate.getPhone() %></td>
                                <%
                                    if(candidate.getResumeAnalysis().equals("DONE")){
                                        %>
                                            <td><%= candidate.getScore() %></td>
                                        <%
                                    }
                                    else{
                                        %>
                                            <td class="text-danger">NOT CALCULATED/NO RESUME</td>
                                        <%
                                    }
                                %>
                                <td>
                                    <a href=<%=baseUrl + "/candidate/viewUpdateResumeView/" + candidate.getId()%>>View/Update Resume</a>
                                    <b>/</b>
                                    <a href=<%=baseUrl + "/candidate/viewUpdateCandidateImage/" + candidate.getId()%>>View/Update Image</a>
                                    <b>/</b>
                                    <a href=<%=baseUrl + "/candidate/viewOrUpdateInterviewView/" + candidate.getId()%>>Interview</a>
                                </td>
                            </tr>
                            <%
                            i++;
                        }
                      %>
                    </tbody>
                  </table>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>