<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<%@ page import="lk.sliit.research.interviewapp.model.domain.Interview"%>
<%@ page import="lk.sliit.research.interviewapp.model.domain.Candidate"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        Interview interview = (Interview) request.getAttribute("interview");
        Candidate candidate = (Candidate) request.getAttribute("candidate");
        int year = Calendar.getInstance().get(Calendar.YEAR);
        String key = "INT" + System.currentTimeMillis();
    %>

    <div class="row">
        <div class="col-md-12">
            <%@include file="../common/adminHeader.jsp" %>
        </div>
    </div>

    <input type="hidden" id="placeInterviewUrl" value=<%=baseUrl+"/interview/placeInterview" %>>
    <input type="hidden" id="replacePlaceInterviewUrl" value=<%=baseUrl+"/candidate/viewAllCandidates/" + candidate.getJobId() %>>

    <div id="interviewCreationAlert" style="display: none">
        <div class="alert alert-danger alert-dismissible fade show" role="alert">
            <strong id="interviewCreationAlertMsg"></strong>
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeInterviewCreationAlert()">x</button>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                <%
                    if(interview == null && candidate.getResumeAnalysis().equals("DONE")){
                        %>
                            <h1>Place Interview</h1>
                            <input type="hidden" id="candidateId" value=<%=candidate.getId()%>>
                            <div class="mb-3">
                                <label for="roomId" class="form-label">Room Id</label>
                                <input type="text" class="form-control" id="roomId">
                            </div>
                            <div class="mb-3">
                                <label for="key" class="form-label">Key</label>
                                <input type="text" class="form-control" id="key" value=<%=key%> readOnly>
                            </div>
                            <div class="mb-3">
                                <label for="dateFixed" class="form-label">Date Fixed</label>
                                <input type="date" class="form-control" id="dateFixed">
                            </div>
                            <button class="btn btn-info" onclick="placeInterview()">Place Interview</button>
                        <%
                    }
                    else if(!candidate.getResumeAnalysis().equals("DONE")){
                        %><br/><div class="text-center"><%
                            %><h5 class="text-danger">Cannot place an interview for this candidate</h5><%
                            %><h5 class="text-danger">Because resume is not analyzed yet!</h5><%
                            %><h5 class="text-danger">Please analyze the resume before proceed!!!</h5><%
                        %></div><%
                    }
                    else{
                        %>
                            <h1>Interview Details</h1>
                            <div class="row">
                                <div class="col-md-6 p-3">
                                    <table class="table table-striped table-bordered" style="width:100%">
                                        <thead>
                                            <tr>
                                                <th scope="col">#</th>
                                                <th scope="col">Name</th>
                                                <th scope="col">Value</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td>1</td>
                                                <td>First Name</td>
                                                <td><%=candidate.getFirstName()%></td>
                                            </tr>
                                            <tr>
                                                <td>2</td>
                                                <td>Last Name</td>
                                                <td><%=candidate.getLastName()%></td>
                                            </tr>
                                            <tr>
                                                <td>3</td>
                                                <td>Email</td>
                                                <td><%=candidate.getEmail()%></td>
                                            </tr>
                                            <tr>
                                                <td>4</td>
                                                <td>Phone</td>
                                                <td><%=candidate.getPhone()%></td>
                                            </tr>
                                            <tr>
                                                <td>5</td>
                                                <td>Resume Score</td>
                                                <td><%=candidate.getScore()%></td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                                <div class="col-md-6 p-3">
                                    <table class="table table-striped table-bordered" style="width:100%">
                                        <thead>
                                            <tr>
                                                <th scope="col">#</th>
                                                <th scope="col">Name</th>
                                                <th scope="col">Value</th>
                                            </tr>
                                        </thead>
                                            <tr>
                                                <td>6</td>
                                                <td>Date Fixed</td>
                                                <td><%=interview.getDateFixed()%></td>
                                            </tr>
                                            <tr>
                                                <td>7</td>
                                                <td>Join Date</td>
                                                <td>
                                                    <%
                                                        if(interview.getJoinDate() != null){
                                                            %><%=interview.getJoinDate()%><%
                                                        }
                                                        else{
                                                            %><p class="text-danger">Interview is not started yet!</p><%
                                                        }
                                                    %>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>8</td>
                                                <td>Room Id</td>
                                                <td><%=interview.getRoomId()%></td>
                                            </tr>
                                            <tr>
                                                <td>9</td>
                                                <td>Key</td>
                                                <td><%=interview.getKey()%></td>
                                            </tr>
                                            <tr>
                                                <td>10</td>
                                                <td>Interview Status</td>
                                                <%
                                                    if(interview.getStatus().equalsIgnoreCase("TO_BE_SELECTED")){
                                                        %>
                                                            <td>
                                                                <a class="btn btn-success" href=<%=baseUrl+"/candidate/updateInterviewSelectionStatus/"+interview.getCandidateId()+"/SELECTED" %>>Select</a>
                                                                <a class="btn btn-danger" href=<%=baseUrl+"/candidate/updateInterviewSelectionStatus/"+interview.getCandidateId()+"/REJECTED" %>>Reject</a>
                                                            </td>
                                                        <%
                                                    }
                                                    else{
                                                        %>
                                                            <td><%=interview.getStatus()%></td>
                                                        <%
                                                    }
                                                %>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        <%
                    }
                %>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>

<script>
    function placeInterview(){
        let candidateId = $('#candidateId').val();
        let dateFixed = $('#dateFixed').val();
        let roomId = $('#roomId').val();
        let key = $('#key').val();

        console.log("candidateId: " + candidateId);
        console.log("dateFixed: " + dateFixed);
        console.log("roomId: " + roomId);
        console.log("key: " + key);

        if (dateFixed.length == 0) {
           alert("Date Fixed is required!");
           return false;
        }

        if (roomId.length == 0) {
           alert("Room Id is required!");
           return false;
        }

        let request = new getInterviewModel(candidateId,dateFixed,roomId,key);
        let jsonRequest = JSON.stringify(request);
        console.log("Request: " + request);
        console.log("Json Request: " + jsonRequest);

		$.ajax({
            type: "POST",
            url: $('input#placeInterviewUrl').val(),
            contentType: 'application/json',
            data: jsonRequest,
            success: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                if(obj == "SUCCESS"){
                    // interview placed success
                    location.reload();
                    window.location.href = $('#replacePlaceInterviewUrl').val();
                }
                else{
                    document.getElementById("interviewCreationAlert").style.display = "block";
                    document.getElementById("interviewCreationAlertMsg").innerHTML = "Error: " + obj;
                }
            }, error: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                document.getElementById("interviewCreationAlert").style.display = "block";
                document.getElementById("interviewCreationAlertMsg").innerHTML = "Error: " + obj;
            }
        });
    }

    function getInterviewModel(candidateId,dateFixed,roomId,key) {
        this.candidateId = candidateId;
        this.dateFixed = dateFixed;
        this.roomId = roomId;
        this.key = key;
    }

    function closeInterviewCreationAlert() {
        document.getElementById("interviewCreationAlert").style.display = "none";
    }
</script>