<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        int candidateId = (int) request.getAttribute("candidateId");
        int year = Calendar.getInstance().get(Calendar.YEAR);
        String uploadCandidateImageMessage = (String) request.getAttribute("uploadCandidateImageMessage");
        String image = (String) request.getAttribute("image");

        if(uploadCandidateImageMessage != null && !uploadCandidateImageMessage.isEmpty()){
            %>
            <div id="viewUpdateCandidateImageAlert">
                <div class="alert alert-danger alert-dismissible fade show" role="alert">
                  <strong><%=uploadCandidateImageMessage%></strong>
                  <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeViewUpdateCandidateImageAlert()">x</button>
                </div>
            </div>
            <%
        }
    %>

    <div class="row">
        <div class="col-md-12">
            <%@include file="../common/adminHeader.jsp" %>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                  <h1>View/Update Candidate Image</h1>
                  <div class="row p-5">
                    <div class="col-md-6 text-center">
                        <h3>Upload Candidate image</h3>
                        <%
                            if(image != null && !image.isEmpty()){
                                %><p class="text-danger">Candidate Image is already uploaded, upload a new one to change the existing one!</p><%
                            }
                        %>
                        <form method="post" action=<%=baseUrl + "/candidate/uploadCandidateImage"%> enctype="multipart/form-data">
                            <input type="hidden" id="candidateId" name="candidateId" value=<%=candidateId%>>
                            <input type="file" id="image" name="image" class="form-control">
                            <br/>
                            <button type="submit" class="btn btn-info">Upload Candidate Image</button>
                        </form>
                    </div>
                    <div class="col-md-6 text-center">
                        <h3>View Candidate Image</h3>
                        <%
                            if(image == null || image.isEmpty()){
                                %>
                                    <p class="text-danger">Please upload a image!</p>
                                    <img src=<%=baseUrl + "/view/uploads/candidate/image/none.jpg"%> width="80%" height="300px"/>
                                <%
                            }
                            else{
                                %>
                                    <img src=<%=baseUrl + "/view/uploads/candidate/image/" + image%> width="100%" height="300px"/>
                                <%
                            }
                        %>
                    </div>
                  </div>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>

<script>
    function closeViewUpdateCandidateImageAlert() {
        document.getElementById("viewUpdateCandidateImageAlert").style.display = "none";
    }
</script>