<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        int candidateId = (int) request.getAttribute("candidateId");
        int year = Calendar.getInstance().get(Calendar.YEAR);
        String uploadCandidateResumeMessage = (String) request.getAttribute("uploadCandidateResumeMessage");
        String resumeAnalysis = (String) request.getAttribute("resumeAnalysis");
        String interviewAnalysis = (String) request.getAttribute("interviewAnalysis");
        String file = (String) request.getAttribute("file");

        if(uploadCandidateResumeMessage != null && !uploadCandidateResumeMessage.isEmpty()){
            %>
            <div id="viewUpdateCandidateViewAlert">
                <div class="alert alert-danger alert-dismissible fade show" role="alert">
                  <strong><%=uploadCandidateResumeMessage%></strong>
                  <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeViewUpdateCandidateViewAlert()">x</button>
                </div>
            </div>
            <%
        }
    %>

    <div class="row">
        <div class="col-md-12">
            <%@include file="../common/adminHeader.jsp" %>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                  <h1>View/Update Resume</h1>
                  <div class="row p-5">
                    <div class="col-md-6 text-center">
                        <h3>Upload Resume</h3>
                        <%
                            if(file != null && !file.isEmpty()){
                                %><p class="text-danger">Resume is already uploaded, upload a new one to change the existing one!</p><%
                            }
                        %>
                        <form method="post" action=<%=baseUrl + "/candidate/uploadCandidateResume"%> enctype="multipart/form-data">
                            <input type="hidden" id="candidateId" name="candidateId" value=<%=candidateId%>>
                            <input type="file" id="file" name="file" class="form-control">
                            <br/>
                            <%
                                if(resumeAnalysis.equals("PROCESSING") || resumeAnalysis.equals("DO_ANALYSIS")){
                                    %>
                                        <p class="text-danger">You cannot upload a new resume till current resume is completely analyzed</p>
                                    <%
                                }
                                else if(interviewAnalysis.equals("INTERVIEW_OVER")
                                            || interviewAnalysis.equals("TO_BE_SELECTED")
                                            || interviewAnalysis.equals("SELECTED")
                                            || interviewAnalysis.equals("REJECTED")
                                            || interviewAnalysis.equals("ERROR_ANALYSIS")){
                                    %>
                                        <p class="text-danger">Interview is already over! you cannot upload resume</p>
                                    <%
                                }
                                else{
                                    %>
                                        <button type="submit" class="btn btn-info">Upload Resume</button>
                                    <%
                                }
                            %>
                        </form>
                    </div>
                    <div class="col-md-6 text-center">
                        <h3>View Resume</h3>
                        <%
                            if(file == null || file.isEmpty()){
                                %>
                                    <p class="text-danger">Please upload a resume!</p>
                                    <img src=<%=baseUrl + "/view/uploads/resume/none.jpg"%> width="80%" height="300px"/>
                                <%
                            }
                            else{
                                %>
                                    <iframe src=<%=baseUrl + "/view/uploads/resume/" + file%> width="100%" height="300px"></iframe>

                                    <%
                                        if(resumeAnalysis.equals("PROCESSING") || resumeAnalysis.equals("DO_ANALYSIS")){
                                            %>
                                                <b><p class="text-warning">Resume is being analyzed...</p></b>
                                            <%
                                        }
                                        else if(resumeAnalysis.equals("DONE")){
                                            %>
                                                <b><p class="text-success">Resume is analyzed</p></b>
                                            <%
                                        }
                                        else{
                                            %>
                                                <a class="btn btn-info" href=<%=baseUrl + "/candidate/analyseResume/" + candidateId%>>Analyse Resume</a>
                                            <%
                                        }
                                    %>
                                <%
                            }
                        %>
                    </div>
                  </div>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>

<script>
    function closeViewUpdateCandidateViewAlert() {
        document.getElementById("viewUpdateCandidateViewAlert").style.display = "none";
    }
</script>