<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        int year = Calendar.getInstance().get(Calendar.YEAR);
        String question = (String) request.getAttribute("question");
        int interviewId = (int) request.getAttribute("interviewId");
    %>

    <input type="hidden" id="interviewOverUrl" value=<%=baseUrl+"/interview/enterKeyView" %>>
    <input type="hidden" id="getQuestionUrl" value=<%=baseUrl+"/interview/getQuestion" %>>
    <input type="hidden" id="questionCount" value="1">

    <input type="hidden" id="interViewId" value=<%=interviewId%>>
    <input type="hidden" id="previousQuestionId" value="1">

    <div id="errorInterviewPanelAlert" style="display: none">
        <div class="alert alert-danger alert-dismissible fade show" role="alert">
          <strong id="errorInterviewPanelAlertMsg">Error</strong>
          <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeErrorInterviewPanelAlert()">x</button>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                <h1>Welcome to the interview!</h1>
                <div class="row">
                    <div class="col-md-12">
                        <div class="card">
                          <div class="card-header">
                            Question
                          </div>
                          <div class="card-body">
                            <blockquote class="blockquote mb-0">
                              <p id="question"><%=question%></p>
                            </blockquote>
                          </div>
                        </div>
                    </div>
                </div>
                <br/>
                <div class="row">
                    <div class="col-md-12">
                        <div class="card">
                          <div class="card-header">
                            Answer <b>You cannot skip a question, if you do not wish to answer leave a blank.</b>
                          </div>
                          <div class="card-body">
                            <blockquote class="blockquote mb-0">
                                <textarea class="form-control" id="note-textarea"></textarea>
                                <button class="btn btn-success mt-2" id="start-record-btn" title="Start Recording">Start Recognition</button>
                                <button class="btn btn-warning mt-2" id="pause-record-btn" title="Pause Recording">Pause Recognition</button>
                                <p id="recording-instructions">Press the <strong>Start Recognition</strong> button and allow access.</p>
                            </blockquote>
                          </div>
                        </div>
                    </div>
                </div>
                <br/>
                <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                  <button class="btn btn-info" type="button" onclick="getQuestion()">Next Question</button>
                </div>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>

<script>
    var noteContent = '';

    $( document ).ready(function() {
        console.log("On load function!")
        speech = document.getElementById("question").innerHTML;
        voiceGen(speech);
    });

    var synth = window.speechSynthesis;
    var voices = [];

    function voiceGen(speech){
        console.log("voiceGen start");

        try {
            var toSpeak = new SpeechSynthesisUtterance(speech);
            var selectedVoiceName = "Microsoft David - English (United States)";
            voices.forEach((voice)=>{
                if(voice.name === selectedVoiceName){
                    toSpeak.voice = voice;
                }
            });
            synth.speak(toSpeak);
        }
        catch(e) {
          console.error("voiceGen error: ");
          console.error(e);
        }

        console.log("voiceGen end");
    }

    function getQuestion(){
        let interViewId = document.getElementById("interViewId").value;
        let previousQuestionId = document.getElementById("previousQuestionId").value;
        let answer = document.getElementById("note-textarea").value;
        let questionCount = parseInt(document.getElementById("questionCount").value);

        let request = new GetQuestionRequestDto(interViewId,previousQuestionId,answer,questionCount);
        let jsonRequest = JSON.stringify(request);
        console.log("Request: " + request);
        console.log("Json Request: " + jsonRequest);

		$.ajax({
            type: "POST",
            url: $('input#getQuestionUrl').val(),
            contentType: 'application/json',
            data: jsonRequest,
            success: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                if(obj.question == "ERROR"){
                    document.getElementById("errorInterviewPanelAlert").style.display = "block";
                    document.getElementById("errorInterviewPanelAlertMsg").innerHTML = "Error: Couldn't load question, please try again...";
                }
                else{
                    if(obj.question == "end"){
                        // end of interview
                        alert("Interview over! you will redirected to the next view!")
                        location.reload();
                        window.location.href = $('#interviewOverUrl').val();
                    }
                    document.getElementById("errorInterviewPanelAlert").style.display = "none";
                    document.getElementById("question").innerHTML = obj.question;
                    document.getElementById("previousQuestionId").value = obj.questionId;
                    document.getElementById("note-textarea").value = "";
                    noteContent = '';

                    questionCount = questionCount + 1;
                    document.getElementById("questionCount").value = questionCount;

                    voiceGen(obj.question);
                }
            }, error: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                document.getElementById("errorInterviewPanelAlert").style.display = "block";
                document.getElementById("errorInterviewPanelAlertMsg").innerHTML = "Error: Couldn't load question, please try again...";
            }
        });
    }

    function closeErrorInterviewPanelAlert() {
        document.getElementById("errorInterviewPanelAlert").style.display = "none";
    }

    function GetQuestionRequestDto(interViewId,previousQuestionId,answer,count) {
        this.interViewId = interViewId;
        this.previousQuestionId = previousQuestionId;
        this.answer = answer;
        this.count = count;
    }

    try {
      var SpeechRecognition = window.SpeechRecognition || window.webkitSpeechRecognition;
      var recognition = new SpeechRecognition();
    }
    catch(e) {
      console.error(e);
      $('.no-browser-support').show();
      $('.app').hide();
    }

    var noteTextarea = $('#note-textarea');
    var instructions = $('#recording-instructions');
    var notesList = $('ul#notes');

    // Get all notes from previous sessions and display them.
    var notes = getAllNotes();
    renderNotes(notes);



    /*-----------------------------
          Voice Recognition
    ------------------------------*/

    // If false, the recording will stop after a few seconds of silence.
    // When true, the silence period is longer (about 15 seconds),
    // allowing us to keep recording even when the user pauses.
    recognition.continuous = true;

    // This block is called every time the Speech APi captures a line.
    recognition.onresult = function(event) {

      // event is a SpeechRecognitionEvent object.
      // It holds all the lines we have captured so far.
      // We only need the current one.
      var current = event.resultIndex;

      // Get a transcript of what was said.
      var transcript = event.results[current][0].transcript;



      // Add the current transcript to the contents of our Note.
      // There is a weird bug on mobile, where everything is repeated twice.
      // There is no official solution so far so we have to handle an edge case.
      var mobileRepeatBug = (current == 1 && transcript == event.results[0][0].transcript);

      if(!mobileRepeatBug) {
        noteContent += transcript;
        noteTextarea.val(noteContent);
      }
    };

    recognition.onstart = function() {
      instructions.text('Voice recognition activated. Try speaking into the microphone.');
    }

    recognition.onspeechend = function() {
      instructions.text('You were quiet for a while so voice recognition turned itself off.');
    }

    recognition.onerror = function(event) {
      if(event.error == 'no-speech') {
        instructions.text('No speech was detected. Try again.');
    };
}



/*-----------------------------
      App buttons and input
------------------------------*/

$('#start-record-btn').on('click', function(e) {
  if (noteContent.length) {
    noteContent += ' ';
  }
  recognition.start();
});


$('#pause-record-btn').on('click', function(e) {
  recognition.stop();
  instructions.text('Voice recognition paused.');
});

// Sync the text inside the text area with the noteContent variable.
noteTextarea.on('input', function() {
  noteContent = $(this).val();
})

$('#save-note-btn').on('click', function(e) {
  recognition.stop();

  if(!noteContent.length) {
    instructions.text('Could not save empty note. Please add a message to your note.');
  }
  else {
    // Save note to localStorage.
    // The key is the dateTime with seconds, the value is the content of the note.
    saveNote(new Date().toLocaleString(), noteContent);

    // Reset variables and update UI.
    noteContent = '';
    renderNotes(getAllNotes());
    noteTextarea.val('');
    instructions.text('Note saved successfully.');
  }

})


notesList.on('click', function(e) {
  e.preventDefault();
  var target = $(e.target);

  // Listen to the selected note.
  if(target.hasClass('listen-note')) {
    var content = target.closest('.note').find('.content').text();
    readOutLoud(content);
  }

  // Delete note.
  if(target.hasClass('delete-note')) {
    var dateTime = target.siblings('.date').text();
    deleteNote(dateTime);
    target.closest('.note').remove();
  }
});



/*-----------------------------
      Speech Synthesis
------------------------------*/

function readOutLoud(message) {
	var speech = new SpeechSynthesisUtterance();

  // Set the text and voice attributes.
	speech.text = message;
	speech.volume = 1;
	speech.rate = 1;
	speech.pitch = 1;

	window.speechSynthesis.speak(speech);
}



/*-----------------------------
      Helper Functions
------------------------------*/

function renderNotes(notes) {
  var html = '';
  if(notes.length) {
    notes.forEach(function(note) {
      html+= `<li class="note">
        <p class="header">
          <span class="date">${note.date}</span>
          <a href="#" class="listen-note" title="Listen to Note">Listen to Note</a>
          <a href="#" class="delete-note" title="Delete">Delete</a>
        </p>
        <p class="content">${note.content}</p>
      </li>`;
    });
  }
  else {
    html = '<li><p class="content">You don\'t have any notes yet.</p></li>';
  }
  notesList.html(html);
}


function saveNote(dateTime, content) {
  localStorage.setItem('note-' + dateTime, content);
}


function getAllNotes() {
  var notes = [];
  var key;
  for (var i = 0; i < localStorage.length; i++) {
    key = localStorage.key(i);
    console.log(i)
    console.log(key)

    if(key.substring(0,5) == 'note-') {
      notes.push({
        date: key.replace('note-',''),
        content: localStorage.getItem(localStorage.key(i))
      });
    }
  }
  console.log(notes)
  return notes;
}


function deleteNote(dateTime) {
  localStorage.removeItem('note-' + dateTime);
}
</script>