<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        int year = Calendar.getInstance().get(Calendar.YEAR);
    %>

    <div class="row">
        <div class="col-md-12">
            <%@include file="../common/adminHeader.jsp" %>
        </div>
    </div>

    <input type="hidden" id="isUniqueNameUrl" value=<%=baseUrl+"/job/isUniqueName" %>>
    <input type="hidden" id="isCreateJobUrl" value=<%=baseUrl+"/job/createJob" %>>
    <input type="hidden" id="replaceCreateJobUrl" value=<%=baseUrl+"/job/listAllJobsView" %>>

    <div id="jobCreationAlert" style="display: none">
        <div class="alert alert-danger alert-dismissible fade show" role="alert">
          <strong>Error</strong> Job creation failed.
          <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeJobCreationAlert()">x</button>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                  <h1>Add Job Details</h1>
                  <div class="mb-3">
                    <label for="name" class="form-label">Job Name</label> <button id="duplicate" type="button" class="btn btn-outline-danger" disabled hidden>Duplicated</button> <button id="unique" type="button" class="btn btn-outline-success" disabled hidden>Unique</button>
                    <input type="text" class="form-control" id="name" aria-describedby="nameHelp" onkeyup="isUniqueName(this.value)">
                    <div id="nameHelp" class="form-text">A unique name for the job. Ex: SSE_5YRS_2022_TEAM-A</div>
                  </div>
                  <div class="mb-3">
                    <label for="title" class="form-label">Job Title</label>
                    <input type="text" class="form-control" id="title" aria-describedby="titleHelp">
                    <div id="titleHelp" class="form-text">Title for the job. Ex: Senior Software Engineer</div>
                  </div>
                  <div class="mb-3">
                    <label for="description" class="form-label">Job Description</label>
                    <textarea class="form-control" id="description" maxlength="5000"></textarea>
                  </div>
                  <button class="btn btn-info" onclick="createJob()">Add Job</button>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>

<script>
    function isUniqueName(name){
        let duplicate = document.getElementById("duplicate");
        let unique = document.getElementById("unique");

        let isUniqueNameStatus = false;
        $.ajax({
            type: "GET",
            url: $('input#isUniqueNameUrl').val() + "/" + name,
            contentType: 'application/json',
            success: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log(typeof jsonResponse);
                console.log(typeof obj);

                if (obj) {
                    unique.removeAttribute("hidden");
                    duplicate.setAttribute("hidden", "hidden");
                } else {
                    duplicate.removeAttribute("hidden");
                    unique.setAttribute("hidden", "hidden");
                }

                console.log("obj: " + obj);
                console.log("Response: " + jsonResponse);
            }, error: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log(typeof jsonResponse);
                console.log(typeof obj);

                if (obj) {
                    unique.removeAttribute("hidden");
                    duplicate.setAttribute("hidden", "hidden");
                } else {
                    duplicate.removeAttribute("hidden");
                    unique.setAttribute("hidden", "hidden");
                }

                console.log("obj: " + obj);
                console.log("Response: " + jsonResponse);
            }
        });
    }

    function createJob(){
        let name = $('#name').val();
        let title = $('#title').val();
        let description = $('#description').val();
        console.log("name: " + name);
        console.log("title: " + title);
        console.log("description: " + description);

        let request = new getJobModel(name, title, description);
        let jsonRequest = JSON.stringify(request);
        console.log("Request: " + request);
        console.log("Json Request: " + jsonRequest);

        let unique = document.getElementById("unique");
        let hidden = unique.getAttribute("hidden");

        if (hidden) {
           alert("Please enter a unique job name!");
           return false;
        }

        if (name.length == 0) {
           alert("Job name is required!");
           return false;
        }

        if (title.length == 0) {
           alert("Job title is required!");
           return false;
        }

        if (description.length == 0) {
           alert("Job description is required!");
           return false;
        }

		$.ajax({
            type: "POST",
            url: $('input#isCreateJobUrl').val(),
            contentType: 'application/json',
            data: jsonRequest,
            success: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                if(obj){
                    // job created success
                    location.reload();
                    window.location.href = $('#replaceCreateJobUrl').val();
                }
                else{
                    document.getElementById("jobCreationAlert").style.display = "block";
                }
            }, error: function (response) {
                let jsonResponse = JSON.stringify(response);
                let obj = JSON.parse(jsonResponse);

                console.log("Response: " + obj)
                console.log("jsonResponse: " + jsonResponse)

                document.getElementById("jobCreationAlert").style.display = "block";
            }
        });
    }

    function getJobModel(name,title,description) {
        this.name = name;
        this.title = title;
        this.description = description;
    }

    function closeJobCreationAlert() {
        document.getElementById("jobCreationAlert").style.display = "none";
    }
</script>