<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<%@ page import="java.util.List"%>
<%@ page import="lk.sliit.research.interviewapp.model.domain.Job"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        int year = Calendar.getInstance().get(Calendar.YEAR);
        List<Job> jobList = (List<Job>) request.getAttribute("jobList");
    %>

    <div class="row">
        <div class="col-md-12">
            <%@include file="../common/adminHeader.jsp" %>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                  <h1>Job List</h1>
                  <div class="row">
                      <div class="ml-5">
                          <form method="post" action=<%=baseUrl + "/job/listAllJobsFilter"%>>
                              <div class="row">
                                  <div><input type="text" class="form-control" id="name" name="name" placeholder="Name"></div>
                                  <div><button type="submit" class="btn btn-info">Search</button></div>
                              </div>
                          </form>
                      </div>
                  </div>

                  <table class="table table-striped table-bordered" style="width:100%">
                    <thead>
                        <tr>
                            <th scope="col">#</th>
                            <th scope="col">ID</th>
                            <th scope="col">Name</th>
                            <th scope="col">Title</th>
                            <th scope="col">Description</th>
                            <th scope="col">Date</th>
                            <th scope="col">Actions</th>
                        </tr>
                    </thead>
                    <tbody>
                      <%
                        int i = 1;
                        for(Job job : jobList){
                            %>
                            <tr>
                                <th scope="row"><%= i %></th>
                                <td><%= job.getId() %></td>
                                <td><%= job.getName() %></td>
                                <td><%= job.getTitle() %></td>
                                <td><%= job.getDescription() %></td>
                                <td><%= job.getDate() %></td>
                                <td>
                                    <a href=<%=baseUrl + "/job/viewUpdateAdsView/" + job.getId()%>>View/Update Ads</a>
                                    <b> / </b>
                                    <a href=<%=baseUrl + "/candidate/viewAllCandidates/" + job.getId()%>>Candidates</a>
                                </td>
                            </tr>
                            <%
                            i++;
                        }
                      %>
                    </tbody>
                  </table>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>