<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page import="org.springframework.web.servlet.support.ServletUriComponentsBuilder"%>
<%@ page import="java.util.Calendar"%>
<html>
<head>
    <title>Sample Page</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.1.1.min.js">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</head>
<body style="background-color:#ededf0">
    <%
        final String baseUrl = ServletUriComponentsBuilder.fromCurrentContextPath().build().toUriString();
        String text = (String) request.getAttribute("text");
        int jobId = (int) request.getAttribute("jobId");
        int year = Calendar.getInstance().get(Calendar.YEAR);
        String uploadJobAdsMessage = (String) request.getAttribute("uploadJobAdsMessage");
        String file = (String) request.getAttribute("file");

        if(uploadJobAdsMessage != null && !uploadJobAdsMessage.isEmpty()){
            %>
            <div id="viewUpdateAdsViewAlert">
                <div class="alert alert-danger alert-dismissible fade show" role="alert">
                  <strong><%=uploadJobAdsMessage%></strong>
                  <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close" onclick="closeViewUpdateAdsViewAlert()">x</button>
                </div>
            </div>
            <%
        }
    %>

    <div class="row">
        <div class="col-md-12">
            <%@include file="../common/adminHeader.jsp" %>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 container" style="height:536px">
            <div class="container">
                  <h1>View/Update Advertisements</h1>
                  <div class="row p-5">
                    <div class="col-md-6 text-center">
                        <h3>Upload Advertisement</h3>
                        <%
                            if(file != null && !file.isEmpty()){
                                %><p class="text-danger">Job advertisement is already uploaded, upload a new one to change the existing one!</p><%
                            }
                        %>
                        <form method="post" action=<%=baseUrl + "/job/uploadJobAds"%> enctype="multipart/form-data">
                            <input type="hidden" id="jobId" name="jobId" value=<%=jobId%>>
                            <input type="file" id="file" name="file" class="form-control">
                            <br/>
                            <button type="submit" class="btn btn-info">Upload Advertisement</button>
                        </form>
                    </div>
                    <div class="col-md-6 text-center">
                        <h3>View Advertisement</h3>
                        <%
                            if(file == null || file.isEmpty()){
                                %>
                                    <p class="text-danger">Please upload a job advertisement!</p>
                                    <img src=<%=baseUrl + "/view/uploads/ads/none.jpg"%> width="80%" height="300px"/>
                                <%
                            }
                            else{
                                %>
                                    <p>File: <%=file%></p>
                                    <iframe src=<%=baseUrl + "/view/uploads/ads/" + file%> width="100%" height="300px"></iframe>
                                <%
                            }
                        %>
                    </div>
                  </div>
            </div>
        </div>
    </div>
    <div class="row bg-info">
        <div class="col-md-12 text-center">
            <p class="mt-2 text-white">Copyright &copy; <%=year%> <%=text%>. All Rights Reserved</p>
        </div>
    </div>
</body>
</html>

<script>
    function closeViewUpdateAdsViewAlert() {
        document.getElementById("viewUpdateAdsViewAlert").style.display = "none";
    }
</script>